#!/bin/bash

# Usage: run.sh <prefix>
# Trains IBM model 1 and then HHHM-fert model
# on data in files <prefix>.train and <prefix>.test
# Then evaluates alignment produced on <prefix>.test against <prefix>.afile
#  gold standard alignment.


training_data=$1


# hadoop=true
hadoop=false

# number of sentence to train - use wc -l to train on whole file
size=`cat $training_data.train | wc -l` 

# alignment direction: reverse=true or false
reverse=false

# initialize with IBM Model 1
sample=0
p0=0.123
echo ./run-model.sh $training_data $reverse $size "default" 1 6 ibm1-classic $hadoop $p0 $sample
time ./run-model.sh $training_data $reverse $size "default" 1 6 ibm1-classic $hadoop $p0 $sample


# train hmm-fertility model
sample=5	# number of samples for each word's alignment
p0=0.4		# the probability of jumping to an empty word
time ./run-model.sh $training_data $reverse $size "ibm1-classic-5" 1 4 hmm-fertility-empty $hadoop $p0 $sample

