
// fet1-main.cc

#include "util/command-line-util.h"
#include "wordalign-common/init.h"

#include "hmm-classic-empty/hmm-classic-empty.h"
using namespace HMM_CLASSIC_EMPTY;

int main(int argc, char* argv[]) {

  UTIL::Command_Line_Util::command_line(argc, argv);

  /*
    output
  */

  cerr << endl;
  cerr << "------------" << endl;
  // system("date");
  cerr << "[message-2010-07-08-04:23] p0" << endl;
  cerr << "[message-2010-07-05-04:00] fwbw is OK" << endl;
  cerr << "[message-2010-07-02-14:12] empty words" << endl;
  cerr << "[message-2010-06-18-03:01] mapreduce" << endl;
  cerr << "[message-2010-06-14-04:10] adding factorial" << endl;
  cerr << "[message-2010-06-14-04:10] no factorial" << endl;
  cerr << "[message-2010-06-14-03:08] polished fertility model" << endl;
  cerr << "[message-2010-06-02-14:18] working on hmm-empty" << endl;
  cerr << "------------" << endl;
  cerr << endl;


  // details
  cerr << "Model: " << MYCONFIG::my_global::FLAGS_wa_model << endl;
  cerr << "uniform-jump: " << MYCONFIG::my_global::FLAGS_uniform_jump << endl;
  cerr << "double_factorial: " << MYCONFIG::my_global::FLAGS_double_factorial << endl;
  cerr << "freq-word-count: " << MYCONFIG::my_global::FLAGS_freq_word_count << endl;
  cerr << "number-of-empty-words: " << MYCONFIG::my_global::FLAGS_number_of_empty_words << endl;
  cerr << "scale: " << MYCONFIG::my_global::FLAGS_scale << endl;
  cerr << "scale-value: " << MYCONFIG::my_global::FLAGS_scale_value << endl;
  cerr << "distortion: " << MYCONFIG::my_global::FLAGS_distortion << endl;
  cerr << endl;
  cerr << "sample: " << MYCONFIG::my_global::FLAGS_sampling_type << endl;
  cerr << "SMALL_LEX_SMOOTH: " << WORDALIGN_COMMON::SMALL_LEX_SMOOTH << endl;
  cerr << "SMALL_JUMP_SMOOTH: " << WORDALIGN_COMMON::SMALL_JUMP_SMOOTH << endl;
  cerr << "SMALL_LAMBDA_SMOOTH: " << WORDALIGN_COMMON::SMALL_LAMBDA_SMOOTH << endl;

  /*
    processing
  */

  Hmm_Classic_Empty hmm_classic_empty;
  if (MYCONFIG::my_global::FLAGS_option_ == "i") {
    WORDALIGN_COMMON::doit();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "m") {
    hmm_classic_empty.map();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "r") {
    hmm_classic_empty.reduce();
  } else {
    assert(false);
  }

  return 0;
}
