
// fet1-main.cc

#include "util/command-line-util.h"
#include "wordalign-common/init.h"

#include "hmm-fertility-empty/hmm-fertility-empty.h"
using namespace HMM_FERTILITY_EMPTY;

int main(int argc, char* argv[]) {

  UTIL::Command_Line_Util::command_line(argc, argv);

  /*
    output
  */

  cerr << endl;
  cerr << "------------" << endl;
  // system("date");
  cerr << "[message-2010-06-21-02:01] mapreduce" << endl;
  cerr << "[message-2010-06-15-20:10] extract hmm-fertility_empty" << endl;
  cerr << "------------" << endl;
  cerr << endl;


  // details
  cerr << "Model: " << MYCONFIG::my_global::FLAGS_wa_model << endl;
  cerr << "uniform-jump: " << MYCONFIG::my_global::FLAGS_uniform_jump << endl;
  cerr << "double_factorial: " << MYCONFIG::my_global::FLAGS_double_factorial << endl;
  cerr << "freq-word-count: " << MYCONFIG::my_global::FLAGS_freq_word_count << endl;
  cerr << "number-of-empty-words: " << MYCONFIG::my_global::FLAGS_number_of_empty_words << endl;
  cerr << "scale: " << MYCONFIG::my_global::FLAGS_scale << endl;
  cerr << "scale-value: " << MYCONFIG::my_global::FLAGS_scale_value << endl;
  cerr << "distortion: " << MYCONFIG::my_global::FLAGS_distortion << endl;
  cerr << endl;
  cerr << "sample: " << MYCONFIG::my_global::FLAGS_sampling_type << endl;
  cerr << "N_training_re_start: " << Hmm_Fertility_Empty::N_training_re_start << endl;
  cerr << "N_training: " << Hmm_Fertility_Empty::N_training << endl;
  cerr << "N_decoding_re_start: " << Hmm_Fertility_Empty::N_decoding_re_start << endl;
  cerr << "N_decoding: " << Hmm_Fertility_Empty::N_decoding << endl;
  cerr << "SMALL_LEX_SMOOTH: " << WORDALIGN_COMMON::SMALL_LEX_SMOOTH << endl;
  cerr << "SMALL_JUMP_SMOOTH: " << WORDALIGN_COMMON::SMALL_JUMP_SMOOTH << endl;
  cerr << "SMALL_LAMBDA_SMOOTH: " << WORDALIGN_COMMON::SMALL_LAMBDA_SMOOTH << endl;
  cerr << endl;

  /*
    processing
  */

  Hmm_Fertility_Empty hmm_fertility_empty;
  if (MYCONFIG::my_global::FLAGS_option_ == "i") {
    WORDALIGN_COMMON::doit();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "m") {
    hmm_fertility_empty.map();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "r") {
    hmm_fertility_empty.reduce();
  } else {
    assert(false);
  }

  return 0;
}
