
// fet1-main.cc

#include "util/command-line-util.h"
#include "wordalign-common/init.h"

#include "ibm1-classic/ibm1-classic.h"
using namespace IBM1_CLASSIC;

int main(int argc, char* argv[]) {

  UTIL::Command_Line_Util::command_line(argc, argv);

  /*
    output
  */

  cerr << endl;
  cerr << "------------" << endl;
  // system("date");
  cerr << "[message-2010-07-08-04:23] p0" << endl;
  cerr << "[message-2010-07-02-14:12] empty words" << endl;
  cerr << "[message-2010-06-16-11:38] ibm1-classic" << endl;

  cerr << "------------" << endl;
  cerr << endl;

  // 1
  cerr << "sampling-type: " << MYCONFIG::my_global::FLAGS_sampling_type << endl;
  cerr << "scale-value: " << MYCONFIG::my_global::FLAGS_scale_value << endl;

  // 2
  assert(MYCONFIG::my_global::FLAGS_distortion != "");

  // 3
  assert(MYCONFIG::my_global::FLAGS_wa_model == "ibm1");

  // details
  cerr << "Model: " << MYCONFIG::my_global::FLAGS_wa_model << endl;
  cerr << "double_factorial: " << MYCONFIG::my_global::FLAGS_double_factorial << endl;
  cerr << "freq-word-count: " << MYCONFIG::my_global::FLAGS_freq_word_count << endl;
  cerr << "number-of-empty-words: " << MYCONFIG::my_global::FLAGS_number_of_empty_words << endl;
  cerr << "scale: " << MYCONFIG::my_global::FLAGS_scale << endl;
  cerr << "scale-value: " << MYCONFIG::my_global::FLAGS_scale_value << endl;
  cerr << "distortion: " << MYCONFIG::my_global::FLAGS_distortion << endl;
  cerr << endl;
  cerr << "sample: " << MYCONFIG::my_global::FLAGS_sampling_type << endl;
  cerr << "SMALL_LEX_SMOOTH: " << WORDALIGN_COMMON::SMALL_LEX_SMOOTH << endl;
  cerr << "SMALL_JUMP_SMOOTH: " << WORDALIGN_COMMON::SMALL_JUMP_SMOOTH << endl;
  cerr << "SMALL_LAMBDA_SMOOTH: " << WORDALIGN_COMMON::SMALL_LAMBDA_SMOOTH << endl;

  /*
    processing
  */

  Ibm1_Classic ibm1_classic;
  if (MYCONFIG::my_global::FLAGS_option_ == "i") {
    WORDALIGN_COMMON::doit();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "m") {
    ibm1_classic.map();
  } else if (MYCONFIG::my_global::FLAGS_option_ == "r") {
    ibm1_classic.reduce();
  } else {
    assert(false);
  }

  return 0;
}
