
#include <iostream>
#include <cmath>

using namespace std;

#include "util/string-util.h"

using namespace UTIL;

int main(int argc, char* argv[]) {
  if (argc != 2) {
    cerr << argv[0] << " input-file" << endl;
    return -1;
  }

  ifstream in(argv[1]);
  string line;
  int line_count = 0;
  while (UTIL::getline(in, &line)) {
    if (line_count % 1000 == 0) {
      cerr << "Reading " << line_count << endl;
    }
    ++line_count;
    
    vector<string> v;
    UTIL::split_string_using(line, "\t", &v);
    if (v.size() == 0) {
      continue;
    }
    if (v.size() != 2) {
      cerr << "Sentence skipped: " << "\t" << line_count << "\t" << line << endl;
      // out << endl;  // output a empty line.
      continue;
    }

    vector<string> v_trg, v_src;
    UTIL::split_string_using(v[0], " ", &v_trg);
    UTIL::remove_redundancy(&v_trg);
    UTIL::split_string_using(v[1], " ", &v_src);
    UTIL::remove_redundancy(&v_src);
    
    for (int i = 0; i < (int)v_trg.size(); ++i) {
      cout << v_trg[i] << " ";
    }
    cout << "\t";
    for (int i = 0; i < (int)v_src.size(); ++i) {
      cout << v_src[i] << " ";
    }
    cout << endl;
  }
  in.close();
}
