
#include "command-line-util.h"
#include "config/global.h"
#include "config/config.h"

namespace UTIL {

  bool Command_Line_Util::ask_for_help(const string& command_line) {
    if ((command_line == "--help") || (command_line == "-h")) {
      return true;
    }
    return false;
  }

  void Command_Line_Util::command_line(int argc, char* argv[]) {

    cerr << "command line input:" << endl;
    for (int i = 0; i < argc; ++i) {
      cerr << argv[i] << " ";
    }  
    cerr << endl;
    
    if (argc <= 6) {
      cerr << "usage: " << argv[0] << " m/r loop p0 samples hadoop multiple-config.ini-files < input > output" << endl;
      exit(-1);
    }
  
    MYCONFIG::my_global::FLAGS_option_ = argv[1];
    MYCONFIG::my_global::FLAGS_loop_ = atoi(argv[2]);
    MYCONFIG::my_global::FLAGS_p0_ = atof(argv[3]);
    MYCONFIG::my_global::FLAGS_samples_ = atoi(argv[4]);
    if (string(argv[5]) == "true") {
      MYCONFIG::my_global::FLAGS_hadoop_ = true;
    } else {
      assert(string(argv[5]) == "false");
      MYCONFIG::my_global::FLAGS_hadoop_ = false;
    }

    for (int i = 6; i < argc; ++i) {
      const string& config_file = argv[i];
      
      MYCONFIG::ConfigFile config(config_file);
      MYCONFIG::my_global::read_config(&config);
    }

    // cerr << "train: " << my_global::FLAGS_train_file.c_str() << endl;
    cerr << "para: " << MYCONFIG::my_global::FLAGS_current_parameter.c_str() << endl;
    cerr << "test: " << MYCONFIG::my_global::FLAGS_test_file.c_str() << endl;
    cerr << "a: " << MYCONFIG::my_global::FLAGS_a_file.c_str() << endl;
    cerr << "p0: " << MYCONFIG::my_global::FLAGS_p0_ << endl;
    cerr << "samples: " << MYCONFIG::my_global::FLAGS_samples_ << endl;
    cerr << endl;

    return;
  }

}  // namespace UTIL

