//
// hash.h
//

#ifndef _util_hash_h_
#define _util_hash_h_

#include <string>
#include <ext/hash_set>
#include <ext/hash_map>

using namespace std;
using namespace __gnu_cxx;

namespace __gnu_cxx
{
  template<> struct hash< std::string >
  {
    size_t operator()( const std::string& x ) const
    {
      return hash< const char* >()( x.c_str() );
    }
  };

  template<> struct hash< pair<std::string, std::string> >
  {
    size_t operator()( const pair<std::string, std::string>& p ) const
    {
      string str = p.first + "\t" + p.second;
      return hash< const char* >()( str.c_str() );
    }
  };
}

#endif  // _util_hash_h_
