
#include "util/string-util.h"
#include <gtest/gtest.h>

TEST(split_string_using, Simple1) {
  vector<string> v;
  UTIL::split_string_using("abcd", "b", &v);
  EXPECT_EQ(2, (int)v.size());
  EXPECT_STREQ("a", v[0].c_str());
  EXPECT_STREQ("cd", v[1].c_str());
}

TEST(split_string_using, Simple2) {
  vector<string> v;
  UTIL::split_string_using("abbd", "b", &v);
  EXPECT_EQ(2, (int)v.size());
  EXPECT_STREQ("a", v[0].c_str());
  EXPECT_STREQ("d", v[1].c_str());
}

TEST(split_string_using, Simple3) {
  vector<string> v;
  UTIL::split_string_using("aaabababcccdd", "bc", &v);
  EXPECT_EQ(4, (int)v.size());
  EXPECT_STREQ("aaa", v[0].c_str());
  EXPECT_STREQ("a", v[1].c_str());
  EXPECT_STREQ("a", v[2].c_str());
  EXPECT_STREQ("dd", v[3].c_str());
}

TEST(split_string_using, Simple4) {
  vector<string> v;
  UTIL::split_string_using("\tabc", "\t", &v);
  EXPECT_EQ(1, (int)v.size());
  EXPECT_STREQ("abc", v[0].c_str());
}

TEST(split_string_using, Simple5) {
  vector<string> v;
  UTIL::split_string_using("abc\t", "\t", &v);
  EXPECT_EQ(1, (int)v.size());
  EXPECT_STREQ("abc", v[0].c_str());
}
