//
// hash.h
//

#ifndef _util_unordered_h_
#define _util_unordered_h_

#include <string>
#include <cassert>
#include <cmath>

#include <vector>
#include <tr1/unordered_set>
#include <tr1/unordered_map>

using namespace std;
using namespace std::tr1;

namespace std {
  namespace tr1 {
    
    template<> struct hash<pair<std::string, std::string> > {
      inline size_t operator()( const pair<std::string, std::string>& p) const {
	return hash<std::string>()(p.first + "\t" + p.second);
	// string str = p.first + "\t" + p.second;
	// return hash< const char* >()( str.c_str() );
      }
    };

    inline const unordered_set<int>& get_1(const unordered_map<int, unordered_set<int> >& m, int i) {
      const unordered_map<int, unordered_set<int> >::const_iterator it = m.find(i);
      assert(it != m.end());
      return it->second;
    }

    /*
    inline const unordered_map<string, double>& get_1(const unordered_map<string, unordered_map<string, double> >& m, const string& str, double eps) {
      const unordered_map<string, unordered_map<string, double> >::const_iterator it = m.find(str);
      if (it == m.end()) {
	return eps;
      }
      return it->second;
    }

    inline const unordered_map<int, double>& get_1(const unordered_map<string, unordered_map<int, double> >& m, const string& str, double eps) {
      const unordered_map<string, unordered_map<int, double> >::const_iterator it = m.find(str);
      if (it == m.end()) {
	return eps;
      }
      return it->second;
    }
    */

    inline double get_1(const unordered_map<string, double>& m, const string& str, double eps) {
      const unordered_map<string, double>::const_iterator it = m.find(str);
      if (it == m.end()) {
	return eps;
      }
      return it->second;
    }

    inline double get_1(const unordered_map<int, double>& m, int i, double eps) {
      const unordered_map<int, double>::const_iterator it = m.find(i);
      if (it == m.end()) {
	return eps;
      }
      return it->second;
    }

    inline double get_2(const unordered_map<string, unordered_map<string, double> >& m, const string& str1, const string& str2, double eps) {
      const unordered_map<string, unordered_map<string, double> >::const_iterator it1 = m.find(str1);
      if (it1 == m.end()) {
	return eps;
      }
      const unordered_map<string, double>& tmp_map = it1->second;
      const unordered_map<string, double>::const_iterator it2 = tmp_map.find(str2);
      if (it2 == tmp_map.end()) {
	return eps;
      }
      return it2->second;
    }

    inline double get_2(const vector<unordered_map<int, double> >& m, int i_pre, int i, double eps) {
      const unordered_map<int, double>& tmp_map = m[i_pre];
      const unordered_map<int, double>::const_iterator it2 = tmp_map.find(i);
      if (it2 == tmp_map.end()) {
	return eps;
      }
      return it2->second;
    }

    inline double get_2(const unordered_map<int, unordered_map<int, double> >& m, const int& i, const int& str, double eps) {
      const unordered_map<int, unordered_map<int, double> >::const_iterator it1 = m.find(i);
      if (it1 == m.end()) {
	return eps;
      }
      const unordered_map<int, double>& tmp_map = it1->second;
      const unordered_map<int, double>::const_iterator it2 = tmp_map.find(str);
      if (it2 == tmp_map.end()) {
	return eps;
      }
      return it2->second;
    }

  }
}

#endif  // _util_unordered_h_
