
// eval-main.cc

// #include "config/config.h"
// #include "fert1/fert1-1.h"
// #include "fert1/fert1-2.h"
// #include "config/global.h"

#include <iostream>
#include <cstdlib>
#include <cassert>
#include "util/unordered-util.h"
#include "wordalign-common/eval.h"

using namespace std;
using namespace WORDALIGN_COMMON;

// using namespace FERT1;
// using namespace CONFIG;

int main(int argc, char* argv[]) {

  if (argc != 6) {
    cerr << "usage: " << argv[0] << " <ec-afile1> <ce-r-afile2> <key-afile3> loop type" << endl;
    exit(-1);
  }

  int loop = atoi(argv[4]);
  string type = argv[5];

  if (type == "ec") {
    // assert(string(argv[1]) == string(argv[2]));
    unordered_map<int, unordered_map<int, unordered_map<int, bool> > > tmp_p;
    unordered_map<int, unordered_map<int, unordered_map<int, bool> > > result1_s;
    Eval::read_afile(argv[1], &result1_s, &tmp_p);
    cout << "type: " << argv[1] << endl;
    Eval::eval_new(argv[3], result1_s, "", loop);
    cout << endl;
    return 0;
  } else if (type == "ce") {
    // assert(string(argv[1]) == string(argv[2]));
    unordered_map<int, unordered_map<int, unordered_map<int, bool> > > tmp_p;
    unordered_map<int, unordered_map<int, unordered_map<int, bool> > > result1_s;
    Eval::read_afile(argv[2], &result1_s, &tmp_p);
    cout << "type: " << argv[2] << endl;
    Eval::eval_new(argv[3], result1_s, "", loop);
    cout << endl;
    return 0;
  } else if (type == "intersection") {
    assert(string(argv[1]) != string(argv[2]));
  } else if (type == "union") {
    assert(string(argv[1]) != string(argv[2]));
  } else {
    assert(false);
  }

  // AND or OR
  unordered_map<int, unordered_map<int, unordered_map<int, bool> > > tmp_p;
  unordered_map<int, unordered_map<int, unordered_map<int, bool> > > result1_s;
  Eval::read_afile(argv[1], &result1_s, &tmp_p);

  unordered_map<int, unordered_map<int, unordered_map<int, bool> > > result2_s;
  Eval::read_afile(argv[2], &result2_s, &tmp_p);

  unordered_map<int, unordered_map<int, unordered_map<int, bool> > > intersection_s;
  unordered_map<int, unordered_map<int, unordered_map<int, bool> > > union_s = result2_s;

  // search over result1_s
  for (unordered_map<int, unordered_map<int, unordered_map<int, bool> > >::iterator it1 = result1_s.begin(); it1 != result1_s.end(); ++it1) {
    int line_count = it1->first;
    const unordered_map<int, unordered_map<int, bool> >& tmp1 = it1->second;
    for (unordered_map<int, unordered_map<int, bool> >::const_iterator it2 = tmp1.begin(); it2 != tmp1.end(); it2++) {
      int i = it2->first;
      const unordered_map<int, bool>& tmp2 = it2->second;
      for (unordered_map<int, bool>::const_iterator it3 = tmp2.begin(); it3 != tmp2.end(); it3++) {
	  int j = it3->first;
	  assert(it3->second);
	  // both result1_s and result2_s are true
	  if (result2_s[line_count][i][j]) {
	    intersection_s[line_count][i][j] = true;
	  }
	  // add result1_s to union_s;
	  union_s[line_count][i][j] = true;
      }
    }
  }

  if (type == "intersection") {
    cout << "type: " << "intersection" << endl;
    Eval::eval_new(argv[3], intersection_s, "intersection", loop);
    cout << endl;
  } else if (type == "union") {
    cout << "type: " << "union" << endl;
    Eval::eval_new(argv[3], union_s, "union", loop);
    cout << endl;
  } else {
    assert(false);
  }

  return 0;
}

